import sensors
reload(sensors)
from soar.graphing import *
from soar.widgets import *
import pickle

runLength = 100
makeGraph = True
showSensors = True
d_desired = 0

proportional = 1
K = 1

proportionalPlusDelay = 2
K1 = 0
K2 = 0

proportionalPlusAngle = 3
K3 = 0
K4 = 0

# select a controller
controller = proportionalPlusDelay

def setup():
    if showSensors:
        robot.w = DrawingWindow(300, 300, -1, 1, -1, 1, "draw")
    else:
        robot.w = False
    robot.e = 0
    robot.ee = 0
    robot.step = 0
    robot.D = []

def step():
#    l,r = sensors.getLR(robot.w)
    l,r,t = sensors.getLRT(robot.w)
    # l = distance to left wall (meters)
    # r = distance to right wall (meters)
    # t = angle of robot (radians)
    d = 0.5*(r-l)

    if controller==proportional:
        angularVelocity = K*(d_desired-d)

    if controller==proportionalPlusDelay:
        robot.ee = robot.e
        robot.e = d_desired-d
        angularVelocity = K1*robot.e+K2*robot.ee

    if controller==proportionalPlusAngle:
        pass

    motorOutput(.1,angularVelocity)
    if makeGraph:
        # Gather data and make a graph at the end
        robot.D.append(l)
        robot.step += 1
        if robot.step == runLength:
            (minVal, maxVal) = (min(robot.D), max(robot.D))
            rangeIncr = (maxVal - minVal)*0.05
            g = GraphingWindow(500, 300, 0, runLength,
                               minVal-rangeIncr, maxVal+rangeIncr, "data")
            # Graph the data values as a function of their indices
            g.graphDiscrete(lambda x: robot.D[x])

            # Save the data into a file
            f = open("leftValues.py", "w")
            pickle.dump(robot.D, f)
            f.close()
